/*
mixed Version 0.1.0 - Mixed Doubles Pairing
Copyright (C) 2002  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include "rnd.h"

#define MAX 300
#define MAXCT 150
#define SZ 100000

int roundtbl[300] = { 0,
   0,3,4,5,5,6,6,7,                /*   4 -  16 */
   7,7,8,8,8,9,9,9,                /*  18 -  32 */
   10,10,10,10,11,11,11,11,        /*  34 -  48 */
   12,12,12,12,13,13,13,13,        /*  50 -  64 */
   14,14,14,14,15,15,15,15,        /*  66 -  80 */
   16,16,16,16,16,16,16,16,        /*  82 -  96 */
   17,17,17,17,17,17,17,17,        /*  98 - 112 */
   18,18,18,18,18,18,18,18,        /* 114 - 128 */
   19,19,19,19,19,19,19,19,        /* 130 - 144 */
   20,20,20,20,20,20,20,20,        /* 146 - 160 */
   20,20,20,20,20,20,20,20,        /* 162 - 176 */
   21,21,21,21,21,21,21,21,        /* 178 - 192 */
   21,21,21,21,21,21,21,21,        /* 194 - 208 */
   22,22,22,22,22,22,22,22,        /* 210 - 224 */
   22,22,22,22,22,22,22,22,        /* 226 - 240 */
   23,23,23,23,23,23,23,23,        /* 242 - 256 */
   23,23,23,23,23,23,23,23,        /* 258 - 272 */
   24,24,24,24,24,24,24,24,        /* 274 - 288 */
   24,24,24,24,24,24 };            /* 290 - 300 */

void putstx(pgm)
char *pgm;
   {
   fprintf(stderr,"Usage: %s pairs\n", pgm);
   fprintf(stderr,"Where pairs is 4,6,8... ,%d\n", MAX);
   fprintf(stderr,"Example: %s 20\n", pgm);
   exit(1);
   } /* putstx */

int main(argc,argv)
int argc;
char **argv;
   {
   int i,indx,hldindx;
   int ch;
   int court,mplayer;
   int fpart,mopp,fopp;
   int round,maxround;
   int mcount,fcount,paircount;
   int id;
   int rslt;
   int try,maxtry;
   int rcmalopp,rcfemprt,rcfemopp;
   int rcoppprt,rcoppopp,rcfemfem;
   int tmp;
   int totpairs;
   int totplayers;
   int totcourts;
   int  male[MAX+16];
   int  female[MAX+16];
   char malopp[SZ];
   char femprt[SZ];
   char femopp[SZ];
   char oppprt[SZ];
   char oppopp[SZ];
   char femfem[SZ];
   char rndlst[MAXCT*MAXCT][32];
   if (argc != 2) putstx(*argv);
   totpairs = atoi(*(argv+1));
   if (totpairs < 4 || totpairs > MAX) putstx(*argv);
   if (totpairs & 1)
      {
      fprintf(stderr,"Pairs must be an even number\n");
      putstx(*argv);
      } /* if odd total pairs */
   sd = (unsigned char *) initrnd();
   totplayers = totpairs;
   totcourts = totpairs >> 1;
   maxround = -999999;
   id = 0;
   while (1) /* group of rounds */
      {
      id++;
      for (i=0;i<SZ;i++)
         {
         malopp[i] = femprt[i] = femopp[i] =
         oppprt[i] = oppopp[i] = femfem[i] = 0;
         } /* init bit map */
      hldindx = round = 0;
      while (round < totplayers) /* for each round */
         {
         round++;
         for (i=0;i<totpairs;i++)
            {
            male[i] = female[i] = i;
            } /* init M and F rosters */
         for (i=totpairs;i<totpairs+1;i++)
            {
            male[i] = female[i] = -9999;
            } /* init M and F rosters */
         mcount = fcount = totpairs;
         court = 0;
         while (court < totcourts)
            {
            court++;
            paircount = rslt = 0;
            rcmalopp = rcfemprt = rcfemopp =
               rcoppprt = rcoppopp = rcfemfem = 1;
            maxtry = mcount << 5;
            try = 0;
            while (rcmalopp && mcount > 1
               && try < maxtry)
               {
               try++;
               indx = rndnum(mcount,sd);
               mplayer = male[indx];
               while (indx < mcount)
                  {
                  male[indx] = male[indx+1];
                  indx++;
                  } /* shift left */
               mcount--;
               if (mcount < 1)
                  {
                  fprintf(stderr,"Out of men\n");
                  exit(1);
                  } /* if out of men */
               indx = rndnum(mcount,sd);
               mopp = male[indx];
               while (indx < mcount)
                  {
                  male[indx] = male[indx+1];
                  indx++;
                  } /* shift left */
               mcount--;
               if (mcount < 0)
                  {
                  fprintf(stderr,"Out of male opponents\n");
                  exit(1);
                  } /* if out of men */
               if (mplayer > mopp)
                  {
                  tmp = mplayer;
                  mplayer = mopp;
                  mopp = tmp;
                  } /* swap */

               i = (mplayer * totpairs) + mopp;
               rcmalopp = malopp[i];
               if (rcmalopp)
                  {
                  male[mcount++] = mplayer;
                  male[mcount++] = mopp;
                  male[mcount] = -9999;
                  } /* if duplicate */
               if (mcount > totplayers)
                  {
                  fprintf(stderr,"Male overflow\n");
                  exit(1);
                  } /* overflow */
               } /* male opponent loop */
            if (try >= maxtry) break;
            maxtry = fcount << 6;
            try = 0;
            while ((rcfemprt || rcoppprt)
               && fcount > 1
               && try < maxtry)
               {
               try++;
               indx = rndnum(fcount,sd);
               fpart = female[indx];
               while (indx < fcount)
                  {
                  female[indx] = female[indx+1];
                  indx++;
                  } /* shift left */
               fcount--;
               if (fcount < 1)
                  {
                  fprintf(stderr,"Out of women (partner)\n");
                  exit(1);
                  } /* if out of women */

               i = (mplayer * totpairs) + fpart;
               rcfemprt = femprt[i];
               i = (mopp * totpairs) + fpart;
               rcoppprt = oppprt[i];
               if (rcfemprt || rcoppprt)
                  {
                  female[fcount++] = fpart;
                  female[fcount] = -9999;
                  } /* if duplicate */
               if (fcount > totplayers)
                  {
                  fprintf(stderr,"Female partner overflow\n");
                  exit(1);
                  } /* female partner overflow */
               } /* test female partner */
            if (try >= maxtry) break;
            maxtry = fcount << 7;
            try = 0;
            while ((rcfemopp || rcoppopp || rcfemfem)
               && fcount > 0
               && try < maxtry)
               {
               try++;
               indx = rndnum(fcount,sd);
               fopp = female[indx];
               while (indx < fcount)
                  {
                  female[indx] = female[indx+1];
                  indx++;
                  } /* shift left */
               fcount--;
               if (fcount < 0)
                  {
                  fprintf(stderr,"Out of women (opponent)\n");
                  exit(1);
                  } /* if out of women */

               i = (mplayer * totpairs) + fopp;
               rcfemopp = femopp[i];
               i = (mopp * totpairs) + fopp;
               rcoppopp = oppopp[i];
               if (fpart < fopp)
                  i = (fpart * totpairs) + fopp;
               else if (fpart > fopp)
                  i = (fopp * totpairs) + fpart;
               rcfemfem = femfem[i];
               if (rcfemopp || rcoppopp || rcfemfem)
                  {
                  female[fcount++] = fopp;
                  female[fcount] = -9999;
                  } /* if duplicate */
               if (fcount > totplayers)
                  {
                  fprintf(stderr,"Female opponent overflow\n");
                  exit(1);
                  } /* female opponent overflow */
               } /* test female opponent */
            if (try >= maxtry) break;
            if (!rcmalopp && !rcfemprt && !rcfemopp
               && !rcoppprt && !rcoppopp && !rcfemfem)
               {
               i = (mplayer * totpairs) + mopp;
               malopp[i] = 1;
               i = (mplayer * totpairs) + fpart;
               femprt[i] = 1;
               i = (mplayer * totpairs) + fopp;
               femopp[i] = 1;
               i = (mopp * totpairs) + fpart;
               oppprt[i] = 1;
               i = (mopp  * totpairs) + fopp;
               oppopp[i] = 1;
               if (fpart < fopp)
                  i = (fpart   * totpairs) + fopp;
               else if (fpart > fopp)
                  i = (fopp    * totpairs) + fpart;
               femfem[i] = 1;
               sprintf(rndlst[hldindx++],
                  "%03d %03d %03d %03d %03d %03d",
                  round, court,
                  mplayer, fpart, mopp, fopp);
               paircount = 1;
               } /* if successful court */
            else
               {
               break;
               } /* incomplete set */
            } /* for each court in round */
         if (paircount != 1)
            {
            if (round >= roundtbl[totpairs>>1]
               && court >= totcourts)
               {
               for (i=0;i<hldindx;i++)
                  {
                  int len,wrtlen,rslt;
                  char buf[128];
                  sprintf(buf,"%04d %s\n",
                     id, rndlst[i]);
                  len = strlen(buf);
                  wrtlen = write(1,buf,len);
                  if (wrtlen != len)
                     {
                     fprintf(stderr,
                        "Error writing to stdout\n");
                     perror("Write error");
                     exit(1);
                     } /* if write err */
                  } /* for each court in rndlst */
               return(0);
               } /* if bigger round */
            break;
            } /* if failed */
         } /* for each round */
      } /* for each id */
   return(0);
   } /* main */
